//In the name of God
#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
using namespace std;

#define num double
#define point pair<int,int>
#define x first
#define y second
const int M=100;
const int N=93;
const num INF=1e15;

num straight(point a,point b)
{
  return sqrt((a.x-b.x)*(a.x-b.x)+(b.y-a.y)*(b.y-a.y));
}

num dist[M][M];
point inp[M];

int main()
{
  ios::sync_with_stdio(0);
  ios_base::sync_with_stdio(0);
  for(int i=0;i<M;++i)
    for(int j=0;j<M;++j)
      dist[i][j]=(i==j)?0:INF;
  for(int i=1;i<=N;++i)
    cin>>inp[i].x>>inp[i].y;
  int a,b;
  while(cin>>a>>b)
    dist[a][b]=dist[b][a]=straight(inp[a],inp[b]);
  for(int k=1;k<=N;++k)
    for(int i=1;i<=N;++i)
      for(int j=1;j<=N;++j)
	dist[i][j]=min(dist[i][j],dist[i][k]+dist[k][j]);
  num ans=0;
  for(int i=1;i<=N;++i)
    for(int j=i+1;j<=N;++j)
      ans+=dist[i][j];
  cout<<fixed<<setprecision(3)<<ans<<endl;
  return 0;
}
