//In the name of God
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define point pair<int,int>
#define x first
#define y second

struct square
{
  point ur;
  int len;
#define maxx (ur.x)
#define maxy (ur.y)
#define minx (ur.x-len)
#define miny (ur.y-len)
  int state(point p)//0:out 1:in 2:border
  {
    if((p.x==minx or p.x==maxx) and (p.y<=maxy and p.y>=miny))
      return 2;
    if((p.y==miny or p.y==maxy) and (p.x<=maxx and p.x>=minx))
      return 2;
    if(p.x<=maxx and p.x>=minx and p.y>=miny and p.y<=maxy)
      return 1;
    return 0;
  }
#undef maxx
#undef maxy
#undef minx
#undef miny
};

bool collide(square s1,square s2)
{
  vector<int> ans;
  for(int i=0;i<2;++i)
    for(int j=0;j<2;++j)
      ans.push_back(s2.state(make_pair(s1.ur.x-i*s1.len,s1.ur.y-j*s1.len)));
  for(int i=0;i<ans.size();++i)
    if(ans[i]==2)
      return true;
  for(int i=1;i<ans.size();++i)
    if(ans[i]!=ans[i-1])
      return true;
  return false;
}


int main()
{
  vector<square> all;
  square s;
  while(cin>>s.ur.x>>s.ur.y>>s.len)
    all.push_back(s);
  cerr<<"SQ:"<<all.size()<<endl;
  int ans=0;
  for(int i=0;i<all.size();++i)
    for(int j=i+1;j<all.size();++j)
      if(collide(all[i],all[j]) or collide(all[j],all[i]))
	ans++;
  cout<<fixed<<ans<<endl;
  return 0;
}
