//In the name of God
#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
using namespace std;

#define num float
#define point pair<int,int>
#define x first
#define y second
const int M=100;
const int N=4;
const num INF=1e15;

num straight(point a,point b)
{
  return sqrt((a.x-b.x)*(a.x-b.x)+(b.y-a.y)*(b.y-a.y));
}

num dist[M][M];
point inp[M];

bool next_of(short p[],int size)
{
  p[size-1]++;
  for(int i=size-1;i>0;--i)
    if(p[i]>1)
      {p[i]=0; p[i-1]++;}
  return (p[0]<=1);
}

int main()
{
  ios::sync_with_stdio(0);
  ios_base::sync_with_stdio(0);
  for(int i=0;i<M;++i)
    for(int j=0;j<M;++j)
      dist[i][j]=(i==j)?0:INF;
  for(int i=1;i<=N;++i)
    cin>>inp[i].x>>inp[i].y;
  int a,b;
  while(cin>>a>>b)
    dist[a][b]=dist[b][a]=straight(inp[a],inp[b]);
  for(int k=1;k<=N;++k)
    for(int i=1;i<=N;++i)
      for(int j=1;j<=N;++j)
	dist[i][j]=min(dist[i][j],dist[i][k]+dist[k][j]);
  num ans=INF*100;
  vector<point> all;
  for(int i=1;i<=N;++i)
    for(int j=i+1;j<=N;++j)
      all.push_back(make_pair(i,j));
  do
    {
      short rotate[all.size()];
      for(int i=0;i<all.size();++i) rotate[i]=0;
      do
	{
	  num current=0;
	  int where=(rotate[0])?all[0].y:all[0].x;
	  for(int i=0;i<all.size();++i)
	    {
	      current+=dist[all[i].x][all[i].y];
	      current+=(rotate[i])?dist[where][all[i].y]:dist[where][all[i].x];
	      where=(rotate[i])?all[i].x:all[i].y;
	    }
	  ans=min(ans,current);
	}while(next_of(rotate,all.size()));
    }while(next_permutation(all.begin(),all.end()));
  cout<<fixed<<setprecision(3)<<ans<<endl;
  return 0;
}
